diff --git a/src/modules/iotjs_module_process.c b/src/modules/iotjs_module_process.c
index 00c296a54..f00036349 100644
--- a/src/modules/iotjs_module_process.c
+++ b/src/modules/iotjs_module_process.c
@@ -142,6 +142,13 @@ JS_FUNCTION(ReadSource) {
   DJS_CHECK_ARGS(1, string);
 
   iotjs_string_t path = JS_GET_ARG(0, string);
+
+  struct stat path_stat;
+  stat(iotjs_string_data(&path), &path_stat);
+  if (!S_ISREG(path_stat.st_mode)) {
+    return JS_CREATE_ERROR(COMMON, "ReadSource error, not a regular file");
+  }
+
   iotjs_string_t code = iotjs_file_read(iotjs_string_data(&path));
 
   iotjs_jval_t ret_val = iotjs_jval_create_string(&code);
diff --git a/test/run_pass/issue/issue-1351.js b/test/run_pass/issue/issue-1351.js
new file mode 100644
index 000000000..4e4de5c63
--- /dev/null
+++ b/test/run_pass/issue/issue-1351.js
@@ -0,0 +1,27 @@
+/* Copyright 2017-present Samsung Electronics Co., Ltd. and other contributors
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+var assert = require('assert');
+var fs = require('fs');
+
+var filePath = process.cwd() + '/resources/';
+
+try {
+  process.readSource(filePath);
+} catch (e) {
+  assert.equal(fs.existsSync(filePath), true);
+  assert.equal(e.name, 'Error');
+  assert.equal(e.message, 'ReadSource error, not a regular file');
+}
diff --git a/test/testsets.json b/test/testsets.json
index b1bfbeb5a..e83f4e33a 100644
--- a/test/testsets.json
+++ b/test/testsets.json
@@ -91,7 +91,7 @@
     { "name": "test_pwm_sync.js", "skip": ["all"], "reason": "need to setup test environment" },
     { "name": "test_spi.js", "skip": ["linux"], "reason": "Differend env on Linux desktop/travis/rpi" },
     { "name": "test_spi_buffer.js", "skip": ["all"], "reason": "need to setup test environment" },
-    { "name": "test_spi_mcp3008.js", "skip": ["all"], "reason": "need to setup test environment" },   
+    { "name": "test_spi_mcp3008.js", "skip": ["all"], "reason": "need to setup test environment" },
     { "name": "test_stream.js" },
     { "name": "test_stream_duplex.js"},
     { "name": "test_timers_arguments.js" },
@@ -111,7 +111,8 @@
     { "name": "issue-816.js" },
     { "name": "issue-1046.js" },
     { "name": "issue-1077.js" },
-    { "name": "issue-1101.js", "skip": ["all"], "reason": "need to setup test environment" }    
+    { "name": "issue-1101.js", "skip": ["all"], "reason": "need to setup test environment" },
+    { "name": "issue-1351.js" }
   ],
   "run_fail":  [
     { "name": "test_assert_equal.js", "expected-failure": true },
